*	Add data for 2002 based on the IEO 2005:

$call 'gams ieosector2005 gdx=ieo2005.gdx'

*	Load the 2005 data into the empty worksheet arrays:

execute_load 'ieo2005.gdx', ws1,ws2,ws3,ws4,ws5,ws6,ws7,ws8,ws9,ws10,ws11,ws12,ws13,ws14,ws15;

*f3	Table D1.  Delivered Energy Consumption in the United States by End-Use Sector and Fuel, 2002-2025
*f4	Table D2.  Delivered Energy Consumption in Canada by End-Use Sector and Fuel, 2002-2025
*f5	Table D3.  Delivered Energy Consumption in Mexico by End-Use Sector and Fuel, 2002-2025
*f6	Table D4.  Delivered Energy Consumption in Western Europe by End-Use Sector and Fuel, 2002-2025
*f7	Table D5.  Delivered Energy Consumption in Japan by End-Use Sector and Fuel, 2002-2025
*f9	Table D6.  Delivered Energy Consumption in Australia/New Zealand by End-Use Sector and Fuel, 2002-2025
*f11	Table D7.  Delivered Energy Consumption in the Former Soviet Union by End-Use Sector and Fuel, 2002-2025
*f12	Table D8.  Delivered Energy Consumption in Eastern Europe by End-Use Sector and Fuel, 2002-2025
*f13	Table D9.  Delivered Energy Consumption in China by End-Use Sector and Fuel, 2002-2025
*f14	Table D10.  Delivered Energy Consumption in India by End-Use Sector and Fuel, 2002-2025
*f8	Table D11.  Delivered Energy Consumption in South Korea by End-Use Sector and Fuel, 2002-2025
*f15	Table D12.  Delivered Energy Consumption in Other Emerging Asia by End-Use Sector and Fuel, 2002-2025
*f16	Table D13.  Delivered Energy Consumption in the Middle East by End-Use Sector and Fuel, 2002-2025
*f17	Table D14.  Delivered Energy Consumption in Africa by End-Use Sector and Fuel, 2002-2025
*f18/f19	Table D15.  Delivered Energy Consumption in Central and South America  by End-Use Sector and Fuel, 2002-2025

set col2002(*,*) /2002.3/;
set smap02(n,s,en) Mapping for end-use data from IEO2005 /

*	Residential
12.Residential.Liquids
13.Residential.Gas
14.Residential.Coal
15.Residential.Electricity
*.16.Residential.Heat
17.Residential.Renewables
18.Residential.Total

*	Commercial.
21.Commercial.Liquids
22.Commercial.Gas
23.Commercial.Coal
24.Commercial.Electricity
*.25.Commercial.Heat
26.Commercial.Renewables
27.Commercial. Total

*	Industrial.
30.Industrial.Liquids
31.Industrial.Gas
32.Industrial.Coal
33.Industrial.Electricity
*.34.Industrial.Heat
35.Industrial.Renewables
36.Industrial.Total

*	Transportation.
39.Transportation.Liquids
40.Transportation.Gas
41.Transportation.Coal
42.Transportation.Electricity
43.Transportation.Total

*	All End-Use Sectors
46.All.Liquids
47.All.Gas
48.All.Coal
49.All.Electricity
*.50.All.Heat
51.All.Renewables
52.All. DeliveredEnergy 
53.All.Electricity-RelatedLosses
54.All.Total
*	Electric Power
57.ElectricPower.Liquids
58.ElectricPower.Gas
59.ElectricPower.Coal
60.ElectricPower.Nuclear
61.ElectricPower.Renewables
62.ElectricPower.Total

*	Total Energy Consumption
65.Total.Liquids
66.Total.Gas
67.Total.Coal
68.Total.Nuclear
69.Total.Renewables
70.Total.Total
/;

loop(col2002(y,nn),
	loop(smap02(n,s,en),
	  f3(s,en,"2002") = ws1(n,nn);
	  f4(s,en,"2002") = ws2(n,nn);
	  f5(s,en,"2002") = ws3(n,nn);
	  f6(s,en,"2002") = ws4(n,nn);
	  f7(s,en,"2002") = ws5(n,nn);
	  f9(s,en,"2002") = ws6(n,nn);
	  f11(s,en,"2002") = ws7(n,nn);
	  f12(s,en,"2002") = ws8(n,nn);
	  f13(s,en,"2002") = ws9(n,nn);
	  f14(s,en,"2002") = ws10(n,nn);
	  f8(s,en,"2002") = ws11(n,nn);
	  f15(s,en,"2002") = ws12(n,nn);
	  f16(s,en,"2002") = ws13(n,nn);
	  f17(s,en,"2002") = ws14(n,nn);

*	Proportionally allocate Central and South American demands to Brazil and the rest of CSA:

	  f18(s,en,"2002")$(f18(s,en,"2004")+f19(s,en,"2004")) = f18(s,en,"2004")/(f18(s,en,"2004")+f19(s,en,"2004")) * ws15(n,nn);
	  f19(s,en,"2002")$(f18(s,en,"2004")+f19(s,en,"2004")) = f19(s,en,"2004")/(f18(s,en,"2004")+f19(s,en,"2004")) * ws15(n,nn);
));
