$title	Read the IEO 2007 Appendix F Workbook (sectoral energy consumption statistics)

$include layout

set	yr /2004,2010,2015,2020,2025,2030/,
	yrmap(n,yr) /2.2004, 3.2010, 4.2015, 5.2020, 6.2025, 7.2030 /;

set droprow(n)/5/, dropcol(n)/8/;

parameter
	f1(*,*,*)	"Total World Delivered Energy Consumption by End-Use Sector and Fuel, (Quadrillion Btu)",
	f2(*,*,*)	"Total OECD Delivered Energy Consumption by End-Use Sector and Fuel (Quadrillion Btu)",
	f3(*,*,*)	"Delivered Energy Consumption in the United States by End-Use Sector and Fuel (Quadrillion Btu)",
	f4(*,*,*)	"Delivered Energy Consumption in Canada by End-Use Sector and Fuel (Quadrillion Btu)",
	f5(*,*,*)	"Delivered Energy Consumption in Mexico by End-Use Sector and Fuel (Quadrillion Btu)",
	f6(*,*,*)	"Delivered Energy Consumption in OECD Europe by End-Use Sector and Fuel (Quadrillion Btu)",
	f7(*,*,*)	"Delivered Energy Consumption in Japan by End-Use Sector and Fuel (Quadrillion Btu)",
	f8(*,*,*)	"Delivered Energy Consumption in South Korea by End-Use Sector and Fuel (Quadrillion Btu)",
	f9(*,*,*)	"Delivered Energy Consumption in Australia/New Zealand by End-Use Sector and Fuel (Quadrillion Btu)",
	f10(*,*,*)	"Total Non-OECD Delivered Energy Consumption by End-Use Sector and Fuel (Quadrillion Btu)",
	f11(*,*,*)	"Delivered Energy Consumption in Russia by End-Use Sector and Fuel (Quadrillion Btu)",
	f12(*,*,*)	"Delivered Energy Consumption Otherin  Non-OECD Europe and Eurasia by End-Use Sector and Fuel (Quadrillion Btu)",
	f13(*,*,*)	"Delivered Energy Consumption in China by End-Use Sector and Fuel (Quadrillion Btu)",
	f14(*,*,*)	"Delivered Energy Consumption in India by End-Use Sector and Fuel (Quadrillion Btu)",
	f15(*,*,*)	"Delivered Energy Consumption in Other Non-OECD Asia by End-Use Sector and Fuel (Quadrillion Btu)",
	f16(*,*,*)	"Delivered Energy Consumption in the Middle East by End-Use Sector and Fuel (Quadrillion Btu)",
	f17(*,*,*)	"Delivered Energy Consumption in Africa by End-Use Sector and Fuel (Quadrillion Btu)",
	f18(*,*,*)	"Delivered Energy Consumption in Brazil by End-Use Sector and Fuel (Quadrillion Btu)",
	f19(*,*,*)	"Delivered Energy Consumption in Other Central and South America by End-Use Sector and Fuel (Quadrillion Btu)";

alias(n,nn);

$offlisting
$include appendixf.gms
$onlisting

loop(yrmap(nn,yr),
	loop(smap(n,s,en),
	  f1(s,en,yr) = ws1(n,nn); ws1(n,nn) = 0;
	  f2(s,en,yr) = ws2(n,nn); ws2(n,nn) = 0;
	  f3(s,en,yr) = ws3(n,nn); ws3(n,nn) = 0;
	  f4(s,en,yr) = ws4(n,nn); ws4(n,nn) = 0;
	  f5(s,en,yr) = ws5(n,nn); ws5(n,nn) = 0;
	  f6(s,en,yr) = ws6(n,nn); ws6(n,nn) = 0;
	  f7(s,en,yr) = ws7(n,nn); ws7(n,nn) = 0;
	  f8(s,en,yr) = ws8(n,nn); ws8(n,nn) = 0;
	  f9(s,en,yr) = ws9(n,nn); ws9(n,nn) = 0;
	  f10(s,en,yr) = ws10(n,nn); ws10(n,nn) = 0;
	  f11(s,en,yr) = ws11(n,nn); ws11(n,nn) = 0;
	  f12(s,en,yr) = ws12(n,nn); ws12(n,nn) = 0;
	  f13(s,en,yr) = ws13(n,nn); ws13(n,nn) = 0;
	  f14(s,en,yr) = ws14(n,nn); ws14(n,nn) = 0;
	  f15(s,en,yr) = ws15(n,nn); ws15(n,nn) = 0;
	  f16(s,en,yr) = ws16(n,nn); ws16(n,nn) = 0;
	  f17(s,en,yr) = ws17(n,nn); ws17(n,nn) = 0;
	  f18(s,en,yr) = ws18(n,nn); ws18(n,nn) = 0;
	  f19(s,en,yr) = ws19(n,nn); ws19(n,nn) = 0;
	);
);

ws1(droprow,n)=0; ws1(n,dropcol)=0; abort$card(ws1) "Not all parameters have been transferred.",ws1;
ws2(droprow,n)=0; ws2(n,dropcol)=0; abort$card(ws2) "Not all parameters have been transferred.",ws2;
ws3(droprow,n)=0; ws3(n,dropcol)=0; abort$card(ws3) "Not all parameters have been transferred.",ws3;
ws4(droprow,n)=0; ws4(n,dropcol)=0; abort$card(ws4) "Not all parameters have been transferred.",ws4;
ws5(droprow,n)=0; ws5(n,dropcol)=0; abort$card(ws5) "Not all parameters have been transferred.",ws5;
ws6(droprow,n)=0; ws6(n,dropcol)=0; abort$card(ws6) "Not all parameters have been transferred.",ws6;
ws7(droprow,n)=0; ws7(n,dropcol)=0; abort$card(ws7) "Not all parameters have been transferred.",ws7;
ws8(droprow,n)=0; ws8(n,dropcol)=0; abort$card(ws8) "Not all parameters have been transferred.",ws8;
ws9(droprow,n)=0; ws9(n,dropcol)=0; abort$card(ws9) "Not all parameters have been transferred.",ws9;
ws10(droprow,n)=0; ws10(n,dropcol)=0; abort$card(ws10) "Not all parameters have been transferred.",ws10;
ws11(droprow,n)=0; ws11(n,dropcol)=0; abort$card(ws11) "Not all parameters have been transferred.",ws11;
ws12(droprow,n)=0; ws12(n,dropcol)=0; abort$card(ws12) "Not all parameters have been transferred.",ws12;
ws13(droprow,n)=0; ws13(n,dropcol)=0; abort$card(ws13) "Not all parameters have been transferred.",ws13;
ws14(droprow,n)=0; ws14(n,dropcol)=0; abort$card(ws14) "Not all parameters have been transferred.",ws14;
ws15(droprow,n)=0; ws15(n,dropcol)=0; abort$card(ws15) "Not all parameters have been transferred.",ws15;
ws16(droprow,n)=0; ws16(n,dropcol)=0; abort$card(ws16) "Not all parameters have been transferred.",ws16;
ws17(droprow,n)=0; ws17(n,dropcol)=0; abort$card(ws17) "Not all parameters have been transferred.",ws17;
ws18(droprow,n)=0; ws18(n,dropcol)=0; abort$card(ws18) "Not all parameters have been transferred.",ws18;
ws19(droprow,n)=0; ws19(n,dropcol)=0; abort$card(ws19) "Not all parameters have been transferred.",ws19;

set sen(*,*);
sen(s,en) = yes;

$batinclude extrapf sen f1 f2 f3 f4 f5 f6 f7 f8 f9 f10 f11 f12 f13 f14 f15 f16 f17 f18 f19

parameter	f(r,s,en,y)	Sectoral demand projections;

f("world",s,en,y) = f1(s,en,y);
f("oecd",s,en,y) = f2(s,en,y);
f("usa",s,en,y) = f3(s,en,y);
f("can",s,en,y) = f4(s,en,y);
f("mex",s,en,y) = f5(s,en,y);
f("oecdeur",s,en,y) = f6(s,en,y);
f("jpn",s,en,y) = f7(s,en,y);
f("kor",s,en,y) = f8(s,en,y);
f("anz",s,en,y) = f9(s,en,y);
f("noecd",s,en,y) = f10(s,en,y);
f("rus",s,en,y) = f11(s,en,y);
f("othnoecdeura",s,en,y) = f12(s,en,y);
f("chn",s,en,y) = f13(s,en,y);
f("ind",s,en,y) = f14(s,en,y);
f("othnoecdasia",s,en,y) = f15(s,en,y);
f("mideast",s,en,y) = f16(s,en,y);
f("africa",s,en,y) = f17(s,en,y);
f("bra",s,en,y) = f18(s,en,y);
f("othcsamer",s,en,y) = f19(s,en,y);

option f:0:2:1;
display f;


set reg /world,oecd,usa,can,mex,oecdeur,jpn,kor,anz,noecd,rus,othnoecdeura,chn,ind,othnoecdasia,mideast,africa,bra,othcsamer/;
parameter	euse	Energy use statistics;
euse(y,reg) = f(reg,"total","total",y);
display euse;
