$title	Read the IEO 2007 Appendix G Workbook (liquids supply)

$include layout

set	yr /1990,2004,2005,2010,2015,2020,2025,2030/,
	yrmap(n,yr) /2.1990, 3.2004, 4.2005, 5.2010, 6.2015, 7.2020, 8.2025, 9.2030/;

set droprow(n)/5/, dropcol(n)/10/;

parameter
	g1(*,*)	"World Total Liquids Production by Region and Country, Reference Case, (Million Barrels Oil Equivalent per Day)"
	g2(*,*)	"World Conventional Liquids Production by Region and Country, Reference Case, (Million Barrels Oil Equivalent per Day)"
	g3(*,*,*) "World Unconventional Liquids Production by Region and Country, Reference Case, (Million Barrels Oil Equivalent per Day)"
	g4(*,*)	"World Total Liquids Production by Region and Country, High Oil Price Case, (Million Barrels Oil Equivalent per Day)"
	g5(*,*)	"World Conventional Liquids Production by Region and Country, High Oil Price Case, (Million Barrels Oil Equivalent per Day)"
	g6(*,*,*) "World Unconventional Liquids Production by Region and Country, High Oil Price Case, (Million Barrels per Day)"
	g7(*,*)	"World Total Liquids Production by Region and Country, Low Oil Price Case, (Million Barrels Oil Equivalent per Day)"
	g8(*,*)	"World Conventional Liquids Production by Region and Country, Low Oil Price Case, (Million Barrels per Day)"
	g9(*,*,*) "World Unconventional Liquids Production by Region and Country, Low Oil Price Case, (Million Barrels Oil Equivalent per Day)";

$offlisting
$include appendixg.gms
$onlisting

loop(yrmap(nn,yr),
	loop(oilmap(n,r),
	  g1(r,yr) = ws1(n,nn); ws1(n,nn)=0;
	  g4(r,yr) = ws4(n,nn); ws4(n,nn)=0;
	  g7(r,yr) = ws7(n,nn); ws7(n,nn)=0;
	);

	loop(conv(n,r),
	  g2(r,yr) = ws2(n,nn); ws2(n,nn)=0;
	  g5(r,yr) = ws5(n,nn); ws5(n,nn)=0;
	  g8(r,yr) = ws8(n,nn); ws8(n,nn)=0;
	);
	  
	loop(unconv(n,r,en),
	  g3(r,en,yr) = ws3(n,nn); ws3(n,nn)=0;
	  g6(r,en,yr) = ws6(n,nn); ws6(n,nn)=0;
	  g9(r,en,yr) = ws9(n,nn); ws9(n,nn)=0;
	);
);

ws1(droprow,n) = 0; ws1(n,dropcol) = 0;	abort$card(ws1)	"Nonzeros were not all processed in ws1",ws1;
ws2(droprow,n) = 0; ws2(n,dropcol) = 0;	abort$card(ws2)	"Nonzeros were not all processed in ws2",ws2;
ws3(droprow,n) = 0; ws3(n,dropcol) = 0;	abort$card(ws3)	"Nonzeros were not all processed in ws3",ws3;
ws4(droprow,n) = 0; ws4(n,dropcol) = 0;	abort$card(ws4)	"Nonzeros were not all processed in ws4",ws4;
ws5(droprow,n) = 0; ws5(n,dropcol) = 0;	abort$card(ws5)	"Nonzeros were not all processed in ws5",ws5;
ws6(droprow,n) = 0; ws6(n,dropcol) = 0;	abort$card(ws6)	"Nonzeros were not all processed in ws6",ws6;
ws7(droprow,n) = 0; ws7(n,dropcol) = 0;	abort$card(ws7)	"Nonzeros were not all processed in ws7",ws7;
ws8(droprow,n) = 0; ws8(n,dropcol) = 0;	abort$card(ws8)	"Nonzeros were not all processed in ws8",ws8;
ws9(droprow,n) = 0; ws9(n,dropcol) = 0;	abort$card(ws9)	"Nonzeros were not all processed in ws9",ws9;

set scn /ref,high,low/;

$batinclude extrapg r g1 g2 g4 g5 g7 g8

set ren(r,en); ren(r,en) = yes;

$batinclude extrapg ren g3 g6 g9

parameter	g(scn,r,*,y)	World oil market statistics;
g("ref",r,"total",y) = g1(r,y);
g("high",r,"total",y) = g4(r,y);
g("low",r,"total",y) = g7(r,y);

g("ref",r,"conven",y) = g2(r,y);
g("high",r,"conven",y) = g5(r,y);
g("low",r,"conven",y) = g8(r,y);

g("ref",r,en,y) = g3(r,en,y);
g("high",r,en,y) = g6(r,en,y);
g("low",r,en,y) = g9(r,en,y);

option g:1:1:2;
display g;

